;
; This source contains the 32*PRECISION bits main routines.
; This means that if PRECISION=1, the computations are done on 32 bits,
; if PRECISION=2, on 64 bits, etc...
;
; We just have to change the only public label.
;
PRECISION		equ	1		;32*PREC bits

TRACELOAD equ	0
;
; To do:
;
; - improve pairability of the program
; - add ContinueFlag
; - add samepower
; - remove BREAKs
;
;

; constants:

FIRST		equ	1
POWER_MAX	equ	4096
THREAD_STOP equ 1

BREAK	macro	value
	mov		[_InternalError], value
	jmp		finished
	endm

.586P
.MODEL FLAT
.STACK 32768

Store	struc
Min		dd	PRECISION dup (?)
Ptr		dd	?
Sum		dd	PRECISION dup (?)
Store	ends

	extrn	_InternalError:dword
	extrn	_DisplayEvent:near
	extrn	_power:dword
	extrn	_start:dword
	extrn	_nbadd:dword
	extrn	_NewRecord:dword
	extrn	_NewRightTerms:dword
	extrn	_Results:dword
	extrn	_DisplayNewRecord:near
	extrn	_Storing:Store
	extrn	_StoringAdd:Store
	extrn	_Powers:dword
	extrn	_EndPowers:dword
	extrn	_THREAD_EVENT:dword
	extrn	_ContinueFlag:dword

.DATA?
ptrfin		dd	?
lastptr		dd	?
cumul		dd	PRECISION dup (?)
saveesp		dd	?
temp		dd	?

.CODE

; macro to simplify all the checks

ConvEAX	macro
		local	label
		cmp		eax,[lastptr]
		jb		short label
		BREAK	1
label:
		sub	eax,offset _Powers
		xor	edx,edx
		mov	ebx,PRECISION*4
		div	ebx
		endm
InvConvEAX	macro
		local	label
		mov		ebx, PRECISION*4
		mul		ebx
		add		eax, offset _Powers
		cmp		eax,[lastptr]
		jb		short label
		BREAK	2
label:
		endm

;
; routine called when an event appears
;
; it stores the current computation in RESULTS
;
DisplayEvent:
if TRACELOAD
	int 3
endif
	pusha

	dec	ebp
	mov	[_NewRightTerms],ebp

	mov	ebp,edi

	mov	eax,edi
	sub	eax,offset _Storing
	xor	edx,edx
	mov	ebx,size Store
	div	ebx
	dec	eax
	cmp	eax,[_NewRightTerms]
	je	bug3
	BREAK	3
bug3:

	mov	edi,offset _StoringAdd
	mov ecx, [_nbadd]
	cmp	ecx,1
	jne	not1b
	mov	edi,offset _Storing
not1b:

	mov esi, offset _Results
adisprecb:
	mov	eax,[edi+Ptr]
	ConvEAX
	mov [esi], eax
	add esi,4
	add	edi,size Store
	dec ecx
	jne adisprecb

	mov	edi,offset _Storing+size Store
isprecb:
	mov	eax,[edi+Ptr]
	ConvEAX
	mov [esi], eax
	add esi, 4
	add	edi,size Store
	cmp	edi,ebp
	jb	isprecb

	call	_DisplayEvent

	popa
	ret
;
; called when a record is broken
;
RecBattu:
	pusha
	mov	[_NewRightTerms],ebp

	mov	ebp,edi

	mov	eax,edi
	sub	eax,offset _Storing
	xor	edx,edx
	mov	ebx,size Store
	div	ebx
	dec	eax
	cmp	eax,[_NewRightTerms]
	je	bug4
	BREAK	4
bug4:

	mov	edi,offset _StoringAdd
	mov ecx, [_nbadd]
	cmp	ecx,1
	jne not1
	mov	edi,offset _Storing
not1:
	mov esi, offset _Results
adisprec:
	mov	eax,[edi+Ptr]
	ConvEAX
	mov [esi], eax
	add esi,4
	add	edi,size Store
	dec ecx
	jne adisprec

	mov	edi,offset _Storing+size Store
isprec:
	mov	eax,[edi+Ptr]
	ConvEAX
	mov [esi], eax
	add esi, 4
	add	edi,size Store
	cmp	edi,ebp
	jb	isprec

;
; now, we check if the sum is correct
;
;	mov	edi,offset _Storing
;	lea esi,[edi+Sum]
;	cmp [_nbadd], 1
;	jne display1a
;	mov	esi,[edi+Ptr]
;display1a:

	mov	edi,offset _Storing

n = 0
	rept	PRECISION
;	mov	eax,[esi+n]
	mov	eax,[edi+Sum+n]
	mov	cumul+n,eax
n = n+4
	endm

	add	edi,size Store
lpdisp:
	mov	esi,[edi+Ptr]
	mov	eax,[esi]
	sub	cumul,eax
n = 4
	rept	PRECISION-1
	mov	eax,[esi+n]
	sbb	cumul+n,eax
n = n+4
	endm
	jnc	bug5
	BREAK	5
bug5:
	add	edi,size Store
	cmp	edi,ebp
	jb	lpdisp
;
; if the result is 0, it's all right !!!
;
	mov	eax,cumul
	if	PRECISION-1
n = 4
	rept	PRECISION-1
	or	eax,cumul+n
n = n+4
	endm
	else
	or	eax,eax
	endif
	je	bug6
	BREAK	6
bug6:

	call	_DisplayNewRecord

	popa
	ret
;
; precomputation of powers
;
precalc:
	pusha

	xor	ebp,ebp
	mov	esi,offset _Powers
pre1:
	cmp	esi,[_EndPowers]
	jae	finpre
	cmp	ebp,POWER_MAX
	jae	finpre

	mov	cumul,ebp
	xor	eax,eax
n = 4
	rept	PRECISION-1
	mov	cumul+n,eax
n = n+4
	endm

	mov	ecx,[_power]

	dec ecx
pre2:
	xor	ebx,ebx
n = 0
	rept	PRECISION
	mov	eax,cumul+n
	mul	ebp
	add	eax,ebx
	mov	cumul+n,eax
	mov	ebx,edx
n = n+4
	endm
	or	ebx,ebx
	jne	finpre
	dec	ecx
	jne	pre2

n = 0
	rept	PRECISION
	mov	eax,cumul+n
	mov	[esi+n],eax
n = n+4
	endm

	inc	ebp
	add	esi,PRECISION*4
	jmp	pre1

finpre:
	mov	[lastptr],esi
	popa
	ret

nextrecord:
	ja	fintest
	sub	esi,PRECISION*4
	cmp	esi,offset _Powers
	jbe	fintest
;
; checks if the last term is a power
;
TestRecord:

if PRECISION eq 1
	mov	eax,[edi+Sum-size Store]
	cmp	eax,[esi]
	jne	nextrecord
endif

if PRECISION eq 2
	mov	eax,[edi+Sum-size Store+4]
	cmp	eax,[esi+4]
	jne	nextrecord
	mov	eax,[edi+Sum-size Store]
	cmp	eax,[esi]
	jne	nextrecord
endif

if PRECISION gt 2
n = PRECISION*4
	rept	PRECISION-1
n = n-4
	mov	eax,[edi+Sum-size Store+n]
	cmp	eax,[esi+n]
	jne	nextrecord
	endm

	mov	eax,[edi+Sum-size Store]
	cmp	eax,[esi]
	jne	nextrecord
endif
;
; if yes, there is a new record !!!
;
newrec:
	mov	[edi+Ptr],esi
	add	edi,size Store
	call	RecBattu
	sub	edi,size Store
fintest:
	dec	ebp
	ret

event:
	call	DisplayEvent
	; if THREAD_STOP
	test eax, THREAD_STOP
	je	noevent
	jmp	finished

	;align	32
;
; here, we substract the powers recursively
;
recurse:
	; if there is one exponent, call the optimised routine
	mov	ebx,[_NewRecord]
	inc	ebp
	sub	ebx,ebp
	cmp	ebx,1
	jbe	TestRecord

	; precalc minimum
	xor	edx,edx
n = PRECISION*4
	rept	PRECISION
n = n-4
	mov	eax,[edi+n-size Store+Sum]
	div	ebx
	mov	[edi+n+Min],eax
	endm

	; if we have an event
	mov	eax, [_THREAD_EVENT]
;	mov ebx, [_samepower]

	or	eax,eax
	jne	event
noevent:
;	or ebx, ebx
;	jne looprec0
	jmp	looprec0
;
; check next power
;
nextrec:
	sub	esi,PRECISION*4
	cmp	esi,offset _Powers
	jbe	recret

looprec0:

if PRECISION eq 1
	mov	eax,[esi]
	cmp	eax,[edi+Min]
endif

if PRECISION eq 2
	mov	eax,[esi+4]
	mov	ebx,[esi]
	cmp	eax,[edi+Min+4]
	jne	@trb
	cmp	ebx,[edi+Min]
@trb:
endif

if PRECISION eq 3
	mov	eax,[esi+8]
	mov	ebx,[esi+4]
	cmp	eax,[edi+Min+8]
	jne	@trb
	mov	eax,[esi]
	cmp	ebx,[edi+Min+4]
	jne	@trb
	cmp	eax,[edi+Min]
@trb:
endif

if PRECISION gt 3
n = PRECISION*4
	rept	PRECISION-1
n = n-4
	mov	eax,[esi+n]
	cmp	eax,[edi+Min+n]
	jne	@trb
	endm

	mov	eax,[esi]
	cmp	eax,[edi+Min]
@trb:
endif
	jb	recret


if PRECISION eq 1
	mov	eax,[edi+Sum-size Store]
	sub	eax,[esi]
	mov	[edi+Sum],eax
	jc	nextrec				; in fact, it's a bug !!!
	je	newrec				; if zero, it's a new record !!!
endif

if PRECISION eq 2
	mov	eax,[edi+Sum-size Store]
	mov	ebx,[edi+Sum-size Store+4]
	sub	eax,[esi]
	sbb	ebx,[esi+4]
	jc	nextrec				; it's a bug !!!

	mov	[edi+Sum],eax
	mov	[edi+Sum+4],ebx

	or	eax,ebx
	je	newrec				; if zero, it's a new record
endif

if PRECISION eq 3
	mov	eax,[edi+Sum-size Store]
	mov	ebx,[edi+Sum-size Store+4]
	sub	eax,[esi]
	sbb	ebx,[esi+4]
	mov	ecx,[edi+Sum-size Store+8]
	mov	[edi+Sum],eax
	sbb	ecx,[esi+8]
	mov	[edi+Sum+4],ebx
	mov	[edi+Sum+8],ecx
	jc	nextrec				; it's a bug !!!

	or	eax,ebx
	or	eax,ecx
	je	newrec				; if zero, it's a new record
endif

if PRECISION gt 3
	; substract
	mov	eax,[edi+Sum-size Store]
	sub	eax,[esi]
	mov	[edi+Sum],eax
n = 4
	rept	PRECISION-1
	mov	eax,[edi+Sum-size Store+n]
	sbb	eax,[esi+n]
	mov	[edi+Sum+n],eax
n = n+4
	endm
	jc	nextrec				; it's a bug
	; check if zero
	mov	eax,[edi+Sum]
n = 4
	rept	PRECISION-1
	or	eax,[edi+Sum+n]
n = n+4
	endm
	je	newrec
endif

	mov	[edi+Ptr],esi
	add	edi,size Store

	call	recurse
simulatecall8:
	mov	esi,[edi+Ptr-size Store]
	sub	edi,size Store
	sub	esi,PRECISION*4
	cmp	esi,offset _Powers
	ja	looprec0
recret:
	dec	ebp
	ret
;
; this routine is called when the left terms have been added
;
recurse0:
	mov	ebp,1
	cmp	esi,offset _Powers
	jbe	rec0ret
rec0a:
	mov	ebx,[_NewRecord]
	xor	edx,edx
;
; 3/1/98: corrected a bug !!! bad divisor
;  should reduce the space search
;
	dec	ebx

n = PRECISION*4
	rept	PRECISION
n = n-4
	mov	eax,[edi+n-size Store+Sum]
	div	ebx
	mov	[edi+n+Min],eax
	endm

	mov	eax,[esi]
	sub	eax,[edi+Min]
n = 4
	rept	PRECISION-1
	mov	eax,[esi+n]
	sbb	eax,[edi+Min+n]
n = n+4
	endm
	jb	rec0ret

	mov	eax,[edi+Sum-size Store]
	sub	eax,[esi]
	mov	[edi+Sum],eax
n = 4
	rept	PRECISION-1
	mov	eax,[edi+Sum-size Store+n]
	sbb	eax,[esi+n]
	mov	[edi+Sum+n],eax
n = n+4
	endm
	jnc	bug7
	BREAK	7
bug7:

	mov	[edi+Ptr],esi
	add	edi,size Store

	call	recurse
simulatecall7:
	sub	edi,size Store
	mov	esi,[edi+Ptr]

	cmp	ebp,1
	je	bug8
	BREAK	8
bug8:
	sub	esi,PRECISION*4
	cmp	esi,offset _Powers
	ja	rec0a

rec0ret:
	ret
;
; this routine is called when there is only one term at the left
;
calc1:
	mov	edi,offset _Storing
	mov	eax,[_start]
	cmp	eax,2
	jae	sup2a
	ret
sup2a:
	InvConvEAX
	mov	esi, eax
	mov	[edi+Ptr],esi

n = 0
	rept	PRECISION
	mov	eax,[esi+n]
	mov	[edi+n+Sum],eax
n = n+4
	endm

	add	edi,size Store
	sub	esi,PRECISION*4*FIRST
	call	recurse0
simulatecall1:
	sub	edi,size Store
	mov	esi,[edi+Ptr]
	ret
;
; this routine is called recursively to add all left terms
;
recurseadd0:
	cmp edi, [ptrfin]
	jb	contadd

	mov	esi,offset _Storing
n = 0
	rept	PRECISION
	mov	eax,[edi+n+Sum-size Store]
	mov	[esi+n+Sum],eax
n = n+4
	endm

	mov	esi,dword ptr [offset _StoringAdd+Ptr]
	sub	esi,PRECISION*4*FIRST
	mov	edi,offset _Storing+size Store
	call	recurse0
simulatecall4:
	mov edi, [ptrfin]
	ret

contadd:
	cmp	esi,offset _Powers
	jbe	nrec0ret

nrec0a:
	mov	eax,[edi+Sum-size Store]
	add	eax,[esi]
	mov	[edi+Sum],eax
n = 4
	rept	PRECISION-1
	mov	eax,[edi+Sum-size Store+n]
	adc	eax,[esi+n]
	mov	[edi+Sum+n],eax
n = n+4
	endm
	jnc	bug9
	BREAK	9
bug9:

	mov	[edi+Ptr],esi
	add	edi,size Store

	call	recurseadd0
simulatecall3:
	sub	edi,size Store
	mov	esi,[edi+Ptr]

	sub	esi,PRECISION*4
	cmp	esi,offset _Powers
	ja	nrec0a
nrec0ret:
	ret


calc0:
	mov	edi,offset _StoringAdd
	mov	eax,[_start]
	cmp	eax,2
	jae	sup2
	ret
sup2:
	InvConvEAX
	mov	esi, eax
	mov	[edi+Ptr],esi

n = 0
	rept	PRECISION
	mov	eax,[esi+n]
	mov	[edi+n+Sum],eax
n = n+4
	endm

	add	edi,size Store
	;sub	esi,PRECISION*4*FIRST
	call	recurseadd0
simulatecall2:

	sub	edi,size Store
	mov	esi,[edi+Ptr]

	add	esi,PRECISION*4
	ret

public _calc1
_calc1:
	pusha

	mov	[saveesp], esp

	call	precalc

	mov eax, [_nbadd]
	mov edx, size Store
	mul edx
	add eax, offset _StoringAdd
	mov [ptrfin], eax

	cmp	[_ContinueFlag], 0
	jne	continuesearch

	cmp [_nbadd],1
	je @cal_1

	call	calc0
	jmp short finished
@cal_1:
	call	calc1
finished:
	mov		esp,[saveesp]
	popa
	xor		eax,eax
	ret
;
; here, we simulate all the CALLs because it's the only solution to continue the saved computation
;
continuesearch:
	push	offset finished			;simulate call calc1

	mov ebp,offset _Results

	mov	edi,offset _Storing
	cmp	[_nbadd],1
	je	@1
	mov	edi,offset _StoringAdd
@1:

	mov	ecx,[_nbadd]
genere1:
;
; simulates call recurse0
;
	mov	eax,[ebp]
	add	ebp,4
	InvConvEAX
	mov	[edi+Ptr],eax
	mov	esi,eax

	cmp	ecx, [_nbadd]
	je	@first

	push	offset simulatecall3

	mov	eax,[edi+Sum-size Store]
	add	eax,[esi]
	mov	[edi+Sum],eax
n = 4
	rept	PRECISION-1
	mov	eax,[edi+Sum-size Store+n]
	adc	eax,[esi+n]
	mov	[edi+Sum+n],eax
n = n+4
	endm
	jnc	bug20
	BREAK	20
bug20:

	jmp	@notfirst
@first:
	mov	eax,offset simulatecall1
	cmp	ecx, 1
	je	@2
	mov	eax,offset simulatecall2
@2:
	push	eax

n = 0
	rept	PRECISION
	mov	eax,[esi+n]
	mov	[edi+n+Sum],eax
n = n+4
	endm
@notfirst:
	add	edi,size Store

	dec	ecx
	jne	genere1

	cmp	[_nbadd], 1
	je	@4
	mov	esi,offset _Storing
n = 0
	rept	PRECISION
	mov	eax,[edi+n+Sum-size Store]
	mov	[esi+n+Sum],eax
n = n+4
	endm
@4:

	mov	edi,offset _Storing+size Store

	mov	ecx, [_NewRightTerms]

	mov	eax,[_NewRecord]
	dec	eax
	mov	[temp],eax

	cmp	[_nbadd], 1
	je	disprecc
	push	offset simulatecall4

disprecc:
	mov	eax,offset simulatecall7
	cmp	ecx,[_NewRightTerms]
	je	@3
	mov	eax,offset simulatecall8
@3:
	push	eax

	mov	eax,[ebp]
	add	ebp,4
	InvConvEAX
	mov	[edi+Ptr], eax
	mov	esi,eax

	mov	ebx,[temp]

	xor	edx,edx
n = PRECISION*4
	rept	PRECISION
n = n-4
	mov	eax,[edi+n-size Store+Sum]
	div	ebx
	mov	[edi+n+Min],eax
	endm

	mov	eax,[edi+Sum-size Store]
	sub	eax,[esi]
	mov	[edi+Sum],eax
n = 4
	rept	PRECISION-1
	mov	eax,[edi+Sum-size Store+n]
	sbb	eax,[esi+n]
	mov	[edi+Sum+n],eax
n = n+4
	endm
	jnc	bug10
	BREAK	10
bug10:

	add	edi,size Store

	dec	[temp]

	dec	ecx
	jne	disprecc

	mov	ebp, [_NewRightTerms]
	inc	ebp

	mov	eax, ebp
	mov	ebx, size Store
	mul	ebx
	add	eax, offset _Storing
	mov	edi, eax

	mov	esi, [edi+Ptr-size Store]
if TRACELOAD
	int 3
endif
	; EBP and EDI are OK !!!
	; Stack for multiple is OK !!!
	; Storing and StoringAdd are OK

	; ESI mal positionn ???

	; we do like if the event was finished
	jmp	noevent

	END
